--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), May 2000
--

class ALARM_LIST

creation
  make

feature

  lst: LINKED_LIST[ALARM];

  current_alarm: INTEGER; -- 0 if alarm thread is not busy

  make is
    do
      current_alarm := 0;
      !!lst.make;
    end;

  set_current_alarm(ca: INTEGER) is
    do
      current_alarm := ca
    end;

  insert(alrm: ALARM) is
    local
      i: INTEGER;
    do
      from
        i := lst.lower
      until
        i > lst.upper or else lst.item(i).abstime >= alrm.abstime
      loop
        i := i + 1;
      end;
      lst.add(alrm,i)
    end;

end -- ALARM_LIST

