--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), September 2000
--

class MAIN

inherit
  THREAD_CONTROL

creation
  make

feature

  num_threads: INTEGER;

  make is
    local
      thr_o: THREAD_ONCE;
      c: INTEGER
    do
      if argument_count /= 1 then
        print_line("Usage: a.out <num-threads>")
      else
        if not argument(1).is_integer or else
           argument(1).to_integer <= 0 then
          print_line("ERROR: expecting an positive integer argument!")
        else
          num_threads := argument(1).to_integer;
          from
            c := 1
          until
            c > num_threads
          loop
            !!thr_o;
            thr_o.start;
            c := c + 1
          end;
          join_all
        end
      end
    end

end -- MAIN

