--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2003
--

class OBJECT_ONCE_EXAMPLE

creation
  make

feature

  obj_id: INTEGER;

  make(id: INTEGER) is
    do
      obj_id := id
    end;

  object_thread_once_proc,dfg,dfhhj(id: INTEGER) is
    once {"object"}
      print_integer(id);
      print_string("->obj_id(");
      print_integer(obj_id);
      print_string(")->object_thread_once_proc:%N");
    end;

  object_thread_once_func(id: INTEGER): INTEGER is
    once {"object"}
      Result := 13*obj_id;
      print_integer(id);
      print_string("->obj_id(");
      print_integer(obj_id);
      print_string(")->object_thread_once_func: ");
      print_string(Result.to_string);
      print_string("%N")
    end;

  object_process_once_proc(id: INTEGER) is
    once {"object","process"}
      print_integer(id);
      print_string("->obj_id(");
      print_integer(obj_id);
      print_string(")->object_process_once_proc:%N");
    end;

  object_process_once_func(id: INTEGER): INTEGER is
    once {"object","process"}
      Result := 21*obj_id;
      print_integer(id);
      print_string("->obj_id(");
      print_integer(obj_id);
      print_string(")->object_process_once_func: ");
      print_string(Result.to_string);
      print_string("%N")
    end;

end -- OBJECT_ONCE_EXAMPLE

