--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), September 2000
--
-- Changed to new global once in August 2003
--

class ONCE_EXAMPLE

inherit
  THREAD

feature {ONCE_EXAMPLE}

  main is
    local
      o,p: A
    do
      global_once_proc;
      global_once_proc;
      global_once_proc;
      o := global_once_func;
      p := global_once_func;
      if p /= o then
        print_string("ERROR: global_once_func%N")
      end;
      p := global_once_func;
      if p /= o then
        print_string("ERROR: global_once_func%N")
      end;
    end;

feature

  global_once_proc is
    once {"process"}
      print_string("once_proc:%N");
    end;

  global_once_func: A is
    once {"process"}
      !!Result;
      print_string("once_refenc_func: ");
      Result.stdout_print;
      print_string("%N")
    end;

end -- ONCE_EXAMPLE

