/* once_thread.h
** This  file  is   free  software,  which   comes  along  with   thread-safe
** SmallEiffel. This software  is distributed  in the  hope that  it will  be
** useful, but WITHOUT  ANY WARRANTY; without  even the  implied warranty  of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. You can modify it  as
** you want, provided this  header is kept unaltered,  and a notification  of
** the changes is  added. You  are allowed to  redistribute it  and sell  it,
** alone or as a part of another product.
**
** (C) Miguel Oliveira e Silva (mos@det.ua.pt), October 2000
**
** Changed in August 2003
**
** Thread safe SmallEiffel
*/

  /* Threaded once support */

typedef struct
{
  void **called_array; /* may contain once functions results */
  int size;
} _Threaded_Once_Data_;

int _is_first_thread_once_routine_call_(int select,int index);
void _set_first_thread_once_routine_call_(int select,int index);
void _set_result_of_thread_once_routine_(int select,int index,void *result);
void *_get_result_of_thread_once_routine_(int select,int index);
void _set_index_object_thread_once_routine(int *index);
void _reset_once_key_(T8 a);
void _reset_all_once_keys_(void);
int _is_first_once_key_routine_call_(char *key,int count);
void _set_once_key_routine_called_(char *key,int *count);

